summaryrefslogtreecommitdiffstats
path: root/tests/ts/swapon
diff options
context:
space:
mode:
authorKarel Zak2012-03-27 12:11:53 +0200
committerKarel Zak2012-03-27 12:11:53 +0200
commitd2efc7a9448981a4c30d7033bd9331b13da063b0 (patch)
treedaa24b1fc6f43f209faaa3c509cfed9756415f7a /tests/ts/swapon
parentdocs: mark udev and list blkid(8) output formats deprecated (diff)
downloadkernel-qcow2-util-linux-d2efc7a9448981a4c30d7033bd9331b13da063b0.tar.gz
kernel-qcow2-util-linux-d2efc7a9448981a4c30d7033bd9331b13da063b0.tar.xz
kernel-qcow2-util-linux-d2efc7a9448981a4c30d7033bd9331b13da063b0.zip
tests: add swapon tests for --fixpgsz and fix signature
Signed-off-by: Karel Zak <kzak@redhat.com>
Diffstat (limited to 'tests/ts/swapon')
-rwxr-xr-xtests/ts/swapon/fixpgsz45
-rwxr-xr-xtests/ts/swapon/fixsig47
2 files changed, 92 insertions, 0 deletions
diff --git a/tests/ts/swapon/fixpgsz b/tests/ts/swapon/fixpgsz
new file mode 100755
index 000000000..ee03dde6a
--- /dev/null
+++ b/tests/ts/swapon/fixpgsz
@@ -0,0 +1,45 @@
+#!/bin/bash
+
+TS_TOPDIR="$(dirname $0)/../.."
+TS_DESC="fix page size"
+
+. $TS_TOPDIR/functions.sh
+ts_init "$*"
+ts_skip_nonroot
+
+set -o pipefail
+
+PAGESIZE=$($TS_HELPER_SYSINFO pagesize)
+
+#
+# Create a swap-area with incompatible page size
+#
+[ "$?" == 0 ] || ts_die "Cannot init device"
+
+if [ $(( 64 * 1024 )) -ne $PAGESIZE ]; then
+ BADSIZE=$(( 64 * 1024 ))
+else
+ BADSIZE=4096
+fi
+
+DEVICE=$(ts_device_init)
+
+$TS_CMD_MKSWAP -L MyFooBarLabel --pagesize $BADSIZE $DEVICE > /dev/null &> /dev/null \
+ || ts_die "Cannot make swap $DEVICE" $DEVICE
+
+ts_device_has "TYPE" "swap" $DEVICE || ts_die "Cannot find swap on $DEVICE" $DEVICE
+
+#
+# Swapon
+#
+LD_LIBRARY_PATH="$U_L_LIBRARY_PATH" \
+ $TS_CMD_SWAPON --fixpgsz $DEVICE &> /dev/null
+
+grep -q $DEVICE /proc/swaps || ts_die "Cannot find $DEVICE in /proc/swaps" $DEVICE
+
+ts_swapoff $DEVICE
+ts_device_deinit $DEVICE
+
+ts_log "Success"
+ts_finalize
+
diff --git a/tests/ts/swapon/fixsig b/tests/ts/swapon/fixsig
new file mode 100755
index 000000000..c3b811e81
--- /dev/null
+++ b/tests/ts/swapon/fixsig
@@ -0,0 +1,47 @@
+#!/bin/bash
+
+TS_TOPDIR="$(dirname $0)/../.."
+TS_DESC="fix signature"
+
+. $TS_TOPDIR/functions.sh
+ts_init "$*"
+ts_skip_nonroot
+
+set -o pipefail
+
+PAGESIZE=$($TS_HELPER_SYSINFO pagesize)
+
+#
+# Create a swap-area
+#
+DEVICE=$(ts_device_init)
+[ "$?" == 0 ] || ts_die "Cannot init device"
+
+$TS_CMD_MKSWAP $DEVICE > /dev/null 2>> $TS_OUTPUT \
+ || ts_die "Cannot make swap $DEVICE" $DEVICE
+
+ts_device_has "TYPE" "swap" $DEVICE || ts_die "Cannot find swap on $DEVICE" $DEVICE
+
+#
+# Rewrite signature to swsuspend
+#
+echo "S2SUSPEND " > $TS_OUTPUT.signature
+dd if=$TS_OUTPUT.signature of=$DEVICE \
+ seek=$(( $PAGESIZE - 10 )) count=10 bs=1 conv=notrunc &> /dev/null
+
+ts_device_has "TYPE" "swsuspend" $DEVICE || ts_die "Cannot find swsuspend on $DEVICE" $DEVICE
+
+#
+# Swapon
+#
+LD_LIBRARY_PATH="$U_L_LIBRARY_PATH" \
+ $TS_CMD_SWAPON $DEVICE &> /dev/null
+
+grep -q $DEVICE /proc/swaps || ts_die "Cannot find $DEVICE in /proc/swaps" $DEVICE
+
+ts_swapoff $DEVICE
+ts_device_deinit $DEVICE
+
+ts_log "Success"
+ts_finalize
+